<template>
  <sidebar-menu
    :menu="menu"
    :collapsed="collapsed"
    :relative="false"
    :show-one-child="true"
    :disable-hover="false"
    :theme="currentTheme === 'dark' ? '' : 'white-theme'"
    @update:collapsed="collapse"
  >
    <template #toggle-icon>
      <i-bi-arrow-bar-left v-if="!collapsed" />
      <i-bi-arrow-bar-right v-else />
    </template>

    <template #dropdown-icon>
      <i-bi-caret-right />
    </template>
  </sidebar-menu>
</template>

<script lang="ts">
import "bootstrap-icons/font/bootstrap-icons.css";
import "bootstrap-icons/font/fonts/bootstrap-icons.woff";
import "bootstrap-icons/font/fonts/bootstrap-icons.woff2";

// For more icons see https://icon-sets.iconify.design/?search-page=1
// Importing using unplugin-icons
import FluentArchive32Regular from "~icons/fluent/archive-32-regular";
import FluentArchiveSettings32Regular from "~icons/fluent/archive-settings-32-regular";

// import the main store
import useMainStore from "@/store/index";
// import the project store
import useProjectStore from "@/modules/project/store";
// import the resource store
import useResourceStore from "@/modules/resource/store";

import { SidebarMenu } from "vue-sidebar-menu";
import "vue-sidebar-menu/dist/vue-sidebar-menu.css";
import type {
  SidebarItem,
  SidebarComponentItem,
  SidebarHeaderItem,
} from "vue-sidebar-menu";
import type {
  ProjectDto,
  ResourceDto,
  RoleDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { Theme } from "@/store/types";

// TODO: Waiting for role implementation (is owner for showing e.g. configuration & metadata)

export default defineComponent({
  components: { SidebarMenu },
  setup() {
    const mainStore = useMainStore();
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { mainStore, projectStore, resourceStore };
  },
  data() {
    return {
      collapsed: false,
    };
  },
  computed: {
    currentTheme(): Theme {
      return this.mainStore.currentTheme;
    },
    currentUserRole(): RoleDto | undefined | null {
      return this.projectStore.currentUserRole;
    },
    menu(): Array<SidebarItem | SidebarComponentItem | SidebarHeaderItem> {
      return [
        {
          href: "/",
          title: this.$t("sidebar.home").toString(),
          icon: "bi bi-house",
        },
        ...this.projectsMenu,
        ...this.projectMenu,
        ...this.resourcesMenu,
        ...this.subProjectsMenu,
        ...this.publicationMenu,
        ...this.settingsMenu,
      ];
    },
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    projects(): ProjectDto[] | null {
      return this.projectStore.topLevelProjects;
    },
    projectMenu(): Array<SidebarItem> {
      if (this.project && this.project.slug) {
        return [
          {
            href: {
              name: "project-page",
              params: { slug: this.project.slug },
            },
            title:
              this.$t("sidebar.project", 1).toString() +
              ": " +
              this.project.displayName,

            icon: "bi bi-folder-symlink",
            attributes: {
              title:
                this.$t("sidebar.project", 1).toString() +
                ": " +
                this.project.displayName,
            },
            exact: true,
          },
        ];
      }
      return [];
    },
    projectsMenu(): Array<SidebarItem> {
      if (this.projects && this.projects.length && !this.project) {
        return [
          {
            title: this.$t("sidebar.project", 2).toString(),
            icon: "bi bi-folder2-open",
            child: this.projects.map((project) => {
              return {
                title: project.displayName,
                href: {
                  name: "project-page",
                  params: { slug: project.slug },
                },
                icon: "bi bi-folder2-open",
              };
            }) as Array<SidebarItem>,
          },
        ];
      }
      return [];
    },
    resources(): ResourceDto[] | null {
      return this.projectStore.currentResources;
    },
    resourcesMenu(): Array<SidebarItem> {
      if (
        this.resources &&
        this.resources.length &&
        this.project &&
        this.project.slug
      ) {
        return [
          {
            title: this.$t("sidebar.resource", 2).toString(),
            icon: "bi bi-archive",
            child: this.resources.map((resource) => {
              return {
                title:
                  (resource.type
                    ? `${this.$t(
                        "resourceTypes." +
                          resource.type.specificType +
                          ".displayName",
                      )}: `
                    : "") + resource.displayName,
                href: {
                  name: "resource-page",
                  params: {
                    slug: this.project ? this.project.slug : undefined,
                    guid: resource.id,
                    dirTrail: "",
                  },
                },
                disabled: resource.maintenanceMode,
                icon: {
                  element: resource.maintenanceMode
                    ? FluentArchiveSettings32Regular
                    : FluentArchive32Regular,
                },
                attributes: {
                  title:
                    (resource.type
                      ? `${this.$t(
                          "resourceTypes." +
                            resource.type.specificType +
                            ".displayName",
                        )}: `
                      : "") + resource.displayName,
                },
                badge: resource.archived
                  ? {
                      text: this.$t("default.archived").toString(),
                      class: "vsm--badge_default",
                    }
                  : undefined,
                exactPath: true,
              };
            }) as Array<SidebarItem>,
          },
        ];
      }
      return [];
    },
    settingsMenu(): Array<SidebarItem> {
      if (this.project && this.project.slug) {
        return [
          {
            title: this.$t("sidebar.settings").toString(),
            href: "",
            icon: "bi bi-gear",
            child: [
              {
                title: this.$t("sidebar.configurationMetadata").toString(),
                href: {
                  name: "project-config-metadata",
                  params: { slug: this.project.slug },
                },
                icon: "bi bi-pencil",
              },
              {
                title: this.$t("sidebar.users").toString(),
                href: {
                  name: "project-members",
                  params: { slug: this.project.slug },
                },
                icon: "bi bi-people",
              },
              {
                title: this.$t("sidebar.quota").toString(),
                href: {
                  name: "project-quota",
                  params: { slug: this.project.slug },
                },
                icon: "bi bi-sliders",
              },
            ],
          },
        ];
      }
      return [];
    },
    sidebarActive(): boolean {
      return this.mainStore.sidebarActive;
    },
    subProjects(): ProjectDto[] | null {
      return this.projectStore.currentSubProjects;
    },
    subProjectsMenu(): Array<SidebarItem> {
      if (this.subProjects && this.subProjects.length) {
        return [
          {
            title: this.$t("sidebar.subProject", 2).toString(),
            href: "",
            icon: "bi bi-folder2-open",
            child: this.subProjects.map((project) => {
              return {
                title: project.displayName,
                href: {
                  name: "project-page",
                  params: { slug: project.slug },
                },
                icon: "bi bi-folder2-open",
                attributes: {
                  title:
                    this.$t("sidebar.subProject", 2).toString() +
                    ": " +
                    project.displayName,
                },
              };
            }) as Array<SidebarItem>,
          },
        ];
      }
      return [];
    },
    publicationMenu(): Array<SidebarItem> {
      if (this.project && this.project.slug) {
        if (
          this.currentUserRole &&
          this.currentUserRole.displayName === "Owner"
        ) {
          return [
            {
              href: {
                name: "project-data-publication",
                params: { slug: this.project.slug },
              },
              title: this.$t("sidebar.projectDataPublication").toString(),
              icon: "bi bi-file-earmark-arrow-up",
              attributes: {
                title: this.$t("sidebar.projectDataPublication").toString(),
              },
            },
          ];
        }
      }
      return [];
    },
  },
  watch: {
    collapsed() {
      this.mainStore.sidebarActive = !this.collapsed;
    },
    sidebarActive() {
      this.collapsed = !this.sidebarActive;
    },
  },
  created() {
    this.collapsed = !this.sidebarActive;
  },
  methods: {
    collapse(collapsed: boolean) {
      this.collapsed = collapsed;
    },
  },
});
</script>

<style lang="scss" scoped>
@import "/src/assets/scss/_custom.scss";

.v-sidebar-menu {
  top: calc(100vh - var(--sidebar-height));
  height: var(--sidebar-height);
  border-radius: 0rem 0.25rem 0.25rem 0rem;
  background: var(--static-element-bg);
  z-index: 998;
}
.v-sidebar-menu :deep(.vsm--toggle-btn) {
  border-radius: 0rem 0rem 0.25rem 0rem;
}
.v-sidebar-menu.vsm_expanded {
  overflow-y: auto;
  overflow-x: hidden;
}
.v-sidebar-menu :deep(.vsm--badge) {
  background-color: #ffc107;
  border-radius: 10rem;
  text-transform: capitalize;
  font-weight: bold;
}
.v-sidebar-menu :deep(.vsm--title) {
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
}
.v-sidebar-menu.vsm_expanded :deep(.vsm--link_open .vsm--link_level-1) {
  background: $primary;
}
.v-sidebar-menu.vsm_expanded
  :deep(.vsm--link_open .vsm--link_level-1 .vsm--icon) {
  background: $primary;
}
.v-sidebar-menu.vsm_collapsed :deep(.vsm--mobile-item .vsm--link_open) {
  background-color: $primary;
}
.v-sidebar-menu.vsm_collapsed :deep(.vsm--mobile-item .vsm--mobile-bg) {
  background-color: $primary;
}
.v-sidebar-menu.vsm_collapsed
  :deep(.vsm--link_level-1.vsm--link_hover .vsm--icon) {
  background-color: $primary;
}
.v-sidebar-menu.vsm_collapsed :deep(.vsm--mobile-bg) {
  width: 400px !important;
}
.v-sidebar-menu.vsm_collapsed :deep(.vsm--item_mobile .vsm--title),
.v-sidebar-menu.vsm_collapsed :deep(.vsm--item_mobile .vsm--child) {
  width: 335px !important;
}
.v-sidebar-menu.vsm_white-theme
  :deep(.vsm--link_level-1.vsm--link_exact-active),
.v-sidebar-menu :deep(.vsm--link_level-1.vsm--link_active) {
  box-shadow: 3px 0px 0px 0px $primary inset;
  -webkit-box-shadow: 3px 0px 0px 0px $primary inset;
}
.v-sidebar-menu :deep(.vsm--link_level-2.vsm--link_active) {
  // Use this to edit the second level element when active
  background-color: var(--bs-primary);
  color: $white;
}
.v-sidebar-menu :deep(.vsm--link_level-2.vsm--link_active .vsm--icon) {
  // Use this to edit the second level element when active
  background-color: var(--bs-primary);
  color: $white;
}
.v-sidebar-menu :deep(.vsm--badge_default) {
  color: $black;
}
</style>
